com.smartgwt.client.widgets

## Class DateChooser

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.DateChooser

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDataChangedHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class DateChooser
      extends VLayout
      implements HasDataChangedHandlers

  Simple interactive calendar interface used to pick a date. Used by the `DateItem` class.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `DateChooser.YearTitleFormatter` A customizer that allows you to alter the year representations used in various places in the DateChooser widget.

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DateChooser()`
    `DateChooser(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addDataChangedHandler(DataChangedHandler handler)` Add a dataChanged handler.
    `void` | `cancelClick()` Fired when the user clicks the cancel button in this date chooser.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getAlternateStyleSuffix()` The text appended to the style name when using `alternateWeekStyles`.
    `java.lang.Boolean` | `getAlternateWeekStyles()` Whether alternating weeks should be drawn in alternating styles.
    `IButton` | `getApplyButton()` When a DateChooser is configured for `a "datetime" value`, clicking on a date cell in the `grid` will not automatically dismiss the DateChooser canvas.
    `java.lang.String` | `getApplyButtonTitle()` Title for the `Apply` button.
    `java.lang.String` | `getBaseBottomButtonStyle()` CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel").
    `java.lang.String` | `getBaseButtonStyle()` Base CSS style applied to this picker's buttons.
    `java.lang.String` | `getBaseFiscalYearStyle()` Base CSS style applied to cells in the `fiscal year column`.
    `java.lang.String` | `getBaseNavButtonStyle()` CSS style to apply to navigation buttons and date display at the top of the component.
    `java.lang.String` | `getBaseWeekdayStyle()` Base CSS style applied to weekdays.
    `java.lang.String` | `getBaseWeekendStyle()` Base CSS style applied to weekends.
    `java.lang.String` | `getBaseWeekStyle()` Base CSS style applied to cells in the `fiscal week column`.
    `HLayout` | `getButtonLayout()` An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered below the `date grid`, and showing the `Today`, `Cancel` and, when working with "datetime" values, `Apply` buttons.
    `IButton` | `getCancelButton()` A button shown below the `calendar grid` which, when clicked, closes the DateChooser without selecting a value.
    `java.lang.String` | `getCancelButtonTitle()` Title for the cancellation button.
    `java.lang.Boolean` | `getCloseOnDateClick()` When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser.
    `boolean` | `getCloseOnEscapeKeypress()` Should this dateChooser be dismissed if the user presses the Escape key?
    `java.util.Date` | `getData()` Get the current value of the picker.
    `DateGrid` | `getDateGrid()` A `ListGrid` subclass, responsible for rendering the calendar view.
    `int` | `getDayNameLength()` How long (how many characters) should be day names be.
    `java.util.Date[]` | `getDisabledDates()` An array of Date instances that should be disabled if they appear in the calendar view.
    `java.lang.String` | `getDisabledWeekdayStyle()` Base CSS style applied to weekday dates which have been `disabled`.
    `java.lang.String` | `getDisabledWeekendStyle()` Base CSS style applied to weekend dates which have been `disabled`.
    `java.lang.Boolean` | `getDisableWeekends()` Whether it should be valid to pick a weekend day.
    `int` | `getEndYear()` Last year that may be selected.
    `int` | `getFirstDayOfWeek()` Day of the week to show in the first column.
    `FiscalCalendar` | `getFiscalCalendar()` Returns the `FiscalCalendar` object that will be used by this DateChooser.
    `IButton` | `getFiscalYearChooserButton()` A button shown in the `navigation layout` which, when clicked, shows a picker for selecting a specific fiscal year.
    `java.lang.String` | `getFiscalYearFieldTitle()` Title for the `fiscal year` field in the date grid.
    `java.lang.String` | `getFiscalYearHeaderStyle()` Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
    `java.lang.Integer` | `getHeaderHeight()` Deprecated. in favor of `navigationLayoutHeight`
    `java.lang.String` | `getHeaderStyle()` CSS style applied to the day-of-week headers.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `IButton` | `getMonthChooserButton()` A button shown in the `navigation layout` that shows a picker for selecting a specific month.
    `java.lang.String` | `getMonthMenuStyle()` Style for the pop-up year menu.
    `HLayout` | `getNavigationLayout()` An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered above the `date grid`, and showing a number of widgets for navigating the DateChooser.
    `int` | `getNavigationLayoutHeight()` Deprecated. in favor of `navigationLayoutHeight`
    `IButton` | `getNextMonthButton()` A button shown in the `navigation layout` that shifts the calendar view forward by a month.
    `java.lang.String` | `getNextMonthIcon()` Icon for the next month button
    `int` | `getNextMonthIconHeight()` Height of the icon for the next month button
    `java.lang.String` | `getNextMonthIconRTL()` Icon for the next month button
    `int` | `getNextMonthIconWidth()` Width of the icon for the next month button if `Page.isRTL()` is true.
    `IButton` | `getNextYearButton()` A button shown in the `navigation layout` that shifts the calendar view forward by a year.
    `java.lang.String` | `getNextYearIcon()` Icon for the next year button
    `int` | `getNextYearIconHeight()` Height of the icon for the next year button
    `java.lang.String` | `getNextYearIconRTL()` Icon for the next year button if `Page.isRTL()` is true.
    `int` | `getNextYearIconWidth()` Width of the icon for the next year button
    `static DateChooser` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `IButton` | `getPreviousMonthButton()` A button shown in the `navigation layout` that shifts the calendar view backward by a month.
    `IButton` | `getPreviousYearButton()` A button shown in the `navigation layout` that shifts the calendar view backward by a year.
    `java.lang.String` | `getPrevMonthIcon()` Icon for the previous month button
    `int` | `getPrevMonthIconHeight()` Height of the icon for the previous month button
    `java.lang.String` | `getPrevMonthIconRTL()` Icon for the previous month button if `Page.isRTL()` is true.
    `int` | `getPrevMonthIconWidth()` Width of the icon for the previous month button
    `java.lang.String` | `getPrevYearIcon()` Icon for the previous year button
    `int` | `getPrevYearIconHeight()` Height of the icon for the previous year button
    `java.lang.String` | `getPrevYearIconRTL()` Icon for the previous year button if `Page.isRTL()` is true.
    `int` | `getPrevYearIconWidth()` Width of the icon for the previous year button
    `java.lang.String` | `getSelectedWeekStyle()` CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
    `java.lang.Boolean` | `getShowApplyButton()` Determines whether the `applyButton` will be displayed.
    `java.lang.Boolean` | `getShowCancelButton()` Determines whether the "Cancel" button will be displayed.
    `java.lang.Boolean` | `getShowFiscalYearChooser()` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `java.lang.Boolean` | `getShowSecondItem()` When showing the `time field`, whether to show the "second" picker.
    `java.lang.Boolean` | `getShowTimeItem()` Whether to show the `time field` for editing the time portion of the date.
    `java.lang.Boolean` | `getShowTodayButton()` Determines whether the "Today" button will be displayed, allowing the user to select the current date.
    `java.lang.Boolean` | `getShowWeekChooser()` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
    `java.lang.Boolean` | `getShowWeekends()` Whether weekend days should be shown.
    `java.lang.String` | `getSkinImgDir()` Overridden directory where images for this widget (such as the month and year button icons) may be found.
    `int` | `getStartYear()` Earliest year that may be selected.
    `TimeItem` | `getTimeItem()` `TimeItem` for editing the time portion of dates.
    `TimeItem` | `getTimeItemProperties()` Custom properties to apply to the `time field` used for editing the time portion of the date.
    `java.lang.String` | `getTimeItemTitle()` Title for the `time field`.
    `IButton` | `getTodayButton()` A button shown below the `calendar grid` which, when clicked, navigates the calendar to today.
    `java.lang.Integer` | `getTodayButtonHeight()` If set specifies a fixed height for the Today and Cancel buttons.
    `java.lang.String` | `getTodayButtonTitle()` Title for "Today" button.
    `java.lang.Boolean` | `getUse24HourTime()` When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time.
    `java.lang.Boolean` | `getUseFirstDayOfFiscalWeek()` When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
    `IButton` | `getWeekChooserButton()` A button shown in the `navigation layout` which shows a picker for selecting a specific week of the year.
    `int[]` | `getWeekendDays()` An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance.
    `java.lang.String` | `getWeekendHeaderStyle()` Optional CSS style applied to the day-of-week headers for weekend days.
    `java.lang.String` | `getWeekFieldTitle()` Title for the `week` field in the date grid.
    `java.lang.String` | `getWeekHeaderStyle()` Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
    `java.lang.String` | `getWeekMenuStyle()` Style for the pop-up week menu.
    `IButton` | `getYearChooserButton()` A button shown in the `navigation layout` that shows a picker for selecting a specific calendar year.
    `java.lang.String` | `getYearMenuStyle()` Style for the pop-up year menu.
    `void` | `setAlternateStyleSuffix(java.lang.String alternateStyleSuffix)` The text appended to the style name when using `alternateWeekStyles`.
    `void` | `setAlternateWeekStyles(java.lang.Boolean alternateWeekStyles)` Whether alternating weeks should be drawn in alternating styles.
    `void` | `setApplyButtonTitle(java.lang.String applyButtonTitle)` Title for the `Apply` button.
    `void` | `setBaseBottomButtonStyle(java.lang.String baseBottomButtonStyle)` CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel").
    `void` | `setBaseButtonStyle(java.lang.String baseButtonStyle)` Base CSS style applied to this picker's buttons.
    `void` | `setBaseFiscalYearStyle(java.lang.String baseFiscalYearStyle)` Base CSS style applied to cells in the `fiscal year column`.
    `void` | `setBaseNavButtonStyle(java.lang.String baseNavButtonStyle)` CSS style to apply to navigation buttons and date display at the top of the component.
    `void` | `setBaseWeekdayStyle(java.lang.String baseWeekdayStyle)` Base CSS style applied to weekdays.
    `void` | `setBaseWeekendStyle(java.lang.String baseWeekendStyle)` Base CSS style applied to weekends.
    `void` | `setBaseWeekStyle(java.lang.String baseWeekStyle)` Base CSS style applied to cells in the `fiscal week column`.
    `void` | `setCancelButtonTitle(java.lang.String cancelButtonTitle)` Title for the cancellation button.
    `void` | `setCloseOnDateClick(java.lang.Boolean closeOnDateClick)` When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser.
    `void` | `setCloseOnEscapeKeypress(boolean closeOnEscapeKeypress)` Should this dateChooser be dismissed if the user presses the Escape key?
    `void` | `setData(java.util.Date date)` Set the picker to show the given date.
    `void` | `setDayNameLength(int dayNameLength)` How long (how many characters) should be day names be.
    `static void` | `setDefaultProperties(DateChooser dateChooserProperties)` Class level method to set the default properties of this class.
    `void` | `setDisabledDates(java.util.Date... disabledDates)` An array of Date instances that should be disabled if they appear in the calendar view.
    `void` | `setDisabledWeekdayStyle(java.lang.String disabledWeekdayStyle)` Base CSS style applied to weekday dates which have been `disabled`.
    `void` | `setDisabledWeekendStyle(java.lang.String disabledWeekendStyle)` Base CSS style applied to weekend dates which have been `disabled`.
    `void` | `setDisableWeekends(java.lang.Boolean disableWeekends)` Whether it should be valid to pick a weekend day.
    `void` | `setEndYear(int endYear)` Last year that may be selected.
    `void` | `setFirstDayOfWeek(int firstDayOfWeek)` Day of the week to show in the first column.
    `void` | `setFiscalCalendar()` Sets the `FiscalCalendar` object that will be used by this DateChooser.
    `void` | `setFiscalCalendar(FiscalCalendar fiscalCalendar)` Sets the `FiscalCalendar` object that will be used by this DateChooser.
    `void` | `setFiscalYearFieldTitle(java.lang.String fiscalYearFieldTitle)` Title for the `fiscal year` field in the date grid.
    `void` | `setFiscalYearHeaderStyle(java.lang.String fiscalYearHeaderStyle)` Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
    `void` | `setHeaderHeight(java.lang.Integer headerHeight)` Deprecated. in favor of `navigationLayoutHeight`
    `void` | `setHeaderStyle(java.lang.String headerStyle)` CSS style applied to the day-of-week headers.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.DateChooserLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMonthMenuStyle(java.lang.String monthMenuStyle)` Style for the pop-up year menu.
    `void` | `setNavigationLayoutHeight(int navigationLayoutHeight)` Deprecated. in favor of `navigationLayoutHeight`
    `void` | `setNextMonthIcon(java.lang.String nextMonthIcon)` Icon for the next month button
    `void` | `setNextMonthIconHeight(int nextMonthIconHeight)` Height of the icon for the next month button
    `void` | `setNextMonthIconRTL(java.lang.String nextMonthIconRTL)` Icon for the next month button
    `void` | `setNextMonthIconWidth(int nextMonthIconWidth)` Width of the icon for the next month button if `Page.isRTL()` is true.
    `void` | `setNextYearIcon(java.lang.String nextYearIcon)` Icon for the next year button
    `void` | `setNextYearIconHeight(int nextYearIconHeight)` Height of the icon for the next year button
    `void` | `setNextYearIconRTL(java.lang.String nextYearIconRTL)` Icon for the next year button if `Page.isRTL()` is true.
    `void` | `setNextYearIconWidth(int nextYearIconWidth)` Width of the icon for the next year button
    `void` | `setPrevMonthIcon(java.lang.String prevMonthIcon)` Icon for the previous month button
    `void` | `setPrevMonthIconHeight(int prevMonthIconHeight)` Height of the icon for the previous month button
    `void` | `setPrevMonthIconRTL(java.lang.String prevMonthIconRTL)` Icon for the previous month button if `Page.isRTL()` is true.
    `void` | `setPrevMonthIconWidth(int prevMonthIconWidth)` Width of the icon for the previous month button
    `void` | `setPrevYearIcon(java.lang.String prevYearIcon)` Icon for the previous year button
    `void` | `setPrevYearIconHeight(int prevYearIconHeight)` Height of the icon for the previous year button
    `void` | `setPrevYearIconRTL(java.lang.String prevYearIconRTL)` Icon for the previous year button if `Page.isRTL()` is true.
    `void` | `setPrevYearIconWidth(int prevYearIconWidth)` Width of the icon for the previous year button
    `void` | `setSelectedWeekStyle(java.lang.String selectedWeekStyle)` CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
    `void` | `setShowApplyButton(java.lang.Boolean showApplyButton)` Determines whether the `applyButton` will be displayed.
    `void` | `setShowCancelButton(java.lang.Boolean showCancelButton)` Determines whether the "Cancel" button will be displayed.
    `void` | `setShowFiscalYearChooser(java.lang.Boolean showFiscalYearChooser)` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `void` | `setShowSecondItem(java.lang.Boolean showSecondItem)` When showing the `time field`, whether to show the "second" picker.
    `void` | `setShowTimeItem(java.lang.Boolean showTimeItem)` Whether to show the `time field` for editing the time portion of the date.
    `void` | `setShowTodayButton(java.lang.Boolean showTodayButton)` Determines whether the "Today" button will be displayed, allowing the user to select the current date.
    `void` | `setShowWeekChooser(java.lang.Boolean showWeekChooser)` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
    `void` | `setShowWeekends(java.lang.Boolean showWeekends)` Whether weekend days should be shown.
    `void` | `setSkinImgDir(java.lang.String skinImgDir)` Overridden directory where images for this widget (such as the month and year button icons) may be found.
    `void` | `setStartYear(int startYear)` Earliest year that may be selected.
    `void` | `setTimeItemProperties(TimeItem timeItemProperties)` Custom properties to apply to the `time field` used for editing the time portion of the date.
    `void` | `setTimeItemTitle(java.lang.String timeItemTitle)` Title for the `time field`.
    `void` | `setTodayButtonHeight(java.lang.Integer todayButtonHeight)` If set specifies a fixed height for the Today and Cancel buttons.
    `void` | `setTodayButtonTitle(java.lang.String todayButtonTitle)` Title for "Today" button.
    `void` | `setUse24HourTime(java.lang.Boolean use24HourTime)` When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time.
    `void` | `setUseFirstDayOfFiscalWeek(java.lang.Boolean useFirstDayOfFiscalWeek)` When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
    `void` | `setWeekendDays(int... weekendDays)` An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance.
    `void` | `setWeekendHeaderStyle(java.lang.String weekendHeaderStyle)` Optional CSS style applied to the day-of-week headers for weekend days.
    `void` | `setWeekFieldTitle(java.lang.String weekFieldTitle)` Title for the `week` field in the date grid.
    `void` | `setWeekHeaderStyle(java.lang.String weekHeaderStyle)` Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
    `void` | `setWeekMenuStyle(java.lang.String weekMenuStyle)` Style for the pop-up week menu.
    `void` | `setYearMenuStyle(java.lang.String yearMenuStyle)` Style for the pop-up year menu.
    `void` | `setYearTitleFormatter(DateChooser.YearTitleFormatter formatter)`
    `void` | `todayClick()` Fired when the user clicks the Today button.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DateChooser

          public DateChooser()

    - #### DateChooser

          public DateChooser(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DateChooser getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setAlternateStyleSuffix

          public void setAlternateStyleSuffix(java.lang.String alternateStyleSuffix)

      The text appended to the style name when using `alternateWeekStyles`.
      Parameters:
        `alternateStyleSuffix` - Default value is "Dark"

    - #### getAlternateStyleSuffix

          public java.lang.String getAlternateStyleSuffix()

      The text appended to the style name when using `alternateWeekStyles`.
      Returns:
        String

    - #### setAlternateWeekStyles

          public void setAlternateWeekStyles(java.lang.Boolean alternateWeekStyles)

      Whether alternating weeks should be drawn in alternating styles. If enabled, the cell style for alternate rows will have `alternateStyleSuffix` appended to it.
      Parameters:
        `alternateWeekStyles` - Default value is null

    - #### getAlternateWeekStyles

          public java.lang.Boolean getAlternateWeekStyles()

      Whether alternating weeks should be drawn in alternating styles. If enabled, the cell style for alternate rows will have `alternateStyleSuffix` appended to it.
      Returns:
        Boolean

    - #### getApplyButton

          public IButton getApplyButton()
                                 throws java.lang.IllegalStateException

      When a DateChooser is configured for `a "datetime" value`, clicking on a date cell in the `grid` will not automatically dismiss the DateChooser canvas. In this case, use the `Apply` button to accept the selected date and time and dismiss the chooser.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setApplyButtonTitle

          public void setApplyButtonTitle(java.lang.String applyButtonTitle)

      Title for the `Apply` button.
      Parameters:
        `applyButtonTitle` - Default value is "Apply"

    - #### getApplyButtonTitle

          public java.lang.String getApplyButtonTitle()

      Title for the `Apply` button.
      Returns:
        String

    - #### setBaseBottomButtonStyle

          public void setBaseBottomButtonStyle(java.lang.String baseBottomButtonStyle)

      CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel"). If null, the CSS style specified in `baseButtonStyle` is used.
      Parameters:
        `baseBottomButtonStyle` - See `CSSStyleName` . Default value is null

    - #### getBaseBottomButtonStyle

          public java.lang.String getBaseBottomButtonStyle()

      CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel"). If null, the CSS style specified in `baseButtonStyle` is used.
      Returns:
        See `CSSStyleName`

    - #### setBaseButtonStyle

          public void setBaseButtonStyle(java.lang.String baseButtonStyle)

      Base CSS style applied to this picker's buttons. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseButtonStyle` - See `CSSStyleName` . Default value is "dateChooserButton"

    - #### getBaseButtonStyle

          public java.lang.String getBaseButtonStyle()

      Base CSS style applied to this picker's buttons. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        See `CSSStyleName`

    - #### setBaseFiscalYearStyle

          public void setBaseFiscalYearStyle(java.lang.String baseFiscalYearStyle)

      Base CSS style applied to cells in the `fiscal year column`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseFiscalYearStyle` - See `CSSStyleName` . Default value is "dateChooserFiscalYearCell"

    - #### getBaseFiscalYearStyle

          public java.lang.String getBaseFiscalYearStyle()

      Base CSS style applied to cells in the `fiscal year column`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        See `CSSStyleName`

    - #### setBaseNavButtonStyle

          public void setBaseNavButtonStyle(java.lang.String baseNavButtonStyle)

      CSS style to apply to navigation buttons and date display at the top of the component. If null, the CSS style specified in `baseButtonStyle` is used.
      Parameters:
        `baseNavButtonStyle` - See `CSSStyleName` . Default value is null

    - #### getBaseNavButtonStyle

          public java.lang.String getBaseNavButtonStyle()

      CSS style to apply to navigation buttons and date display at the top of the component. If null, the CSS style specified in `baseButtonStyle` is used.
      Returns:
        See `CSSStyleName`

    - #### setBaseWeekdayStyle

          public void setBaseWeekdayStyle(java.lang.String baseWeekdayStyle)

      Base CSS style applied to weekdays. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseButtonStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseWeekdayStyle` - See `CSSStyleName` . Default value is "dateChooserWeekday"

    - #### getBaseWeekdayStyle

          public java.lang.String getBaseWeekdayStyle()

      Base CSS style applied to weekdays. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseButtonStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        See `CSSStyleName`

    - #### setBaseWeekendStyle

          public void setBaseWeekendStyle(java.lang.String baseWeekendStyle)

      Base CSS style applied to weekends. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseWeekdayStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseWeekendStyle` - See `CSSStyleName` . Default value is "dateChooserWeekend"

    - #### getBaseWeekendStyle

          public java.lang.String getBaseWeekendStyle()

      Base CSS style applied to weekends. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseWeekdayStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        See `CSSStyleName`

    - #### setBaseWeekStyle

          public void setBaseWeekStyle(java.lang.String baseWeekStyle)

      Base CSS style applied to cells in the `fiscal week column`.
      Parameters:
        `baseWeekStyle` - See `CSSStyleName` . Default value is "dateChooserWeekCell"

    - #### getBaseWeekStyle

          public java.lang.String getBaseWeekStyle()

      Base CSS style applied to cells in the `fiscal week column`.
      Returns:
        See `CSSStyleName`

    - #### getButtonLayout

          public HLayout getButtonLayout()
                                  throws java.lang.IllegalStateException

      An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered below the `date grid`, and showing the `Today`, `Cancel` and, when working with "datetime" values, `Apply` buttons.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        HLayout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getCancelButton

          public IButton getCancelButton()
                                  throws java.lang.IllegalStateException

      A button shown below the `calendar grid` which, when clicked, closes the DateChooser without selecting a value.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setCancelButtonTitle

          public void setCancelButtonTitle(java.lang.String cancelButtonTitle)

      Title for the cancellation button.
      Parameters:
        `cancelButtonTitle` - Default value is "Cancel"

    - #### getCancelButtonTitle

          public java.lang.String getCancelButtonTitle()

      Title for the cancellation button.
      Returns:
        String

    - #### setCloseOnDateClick

          public void setCloseOnDateClick(java.lang.Boolean closeOnDateClick)

      When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser. When a `time portion` is required, however, the `apply button` must be clicked to close the chooser, by default.

      Set this attribute to true to have the DateChooser close when a user clicks in a date-cell, even if the `timeItem` is showing.

      Parameters:
        `closeOnDateClick` - Default value is null

    - #### getCloseOnDateClick

          public java.lang.Boolean getCloseOnDateClick()

      When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser. When a `time portion` is required, however, the `apply button` must be clicked to close the chooser, by default.

      Set this attribute to true to have the DateChooser close when a user clicks in a date-cell, even if the `timeItem` is showing.

      Returns:
        Boolean

    - #### setCloseOnEscapeKeypress

          public void setCloseOnEscapeKeypress(boolean closeOnEscapeKeypress)
                                        throws java.lang.IllegalStateException

      Should this dateChooser be dismissed if the user presses the Escape key?
      Parameters:
        `closeOnEscapeKeypress` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCloseOnEscapeKeypress

          public boolean getCloseOnEscapeKeypress()

      Should this dateChooser be dismissed if the user presses the Escape key?
      Returns:
        boolean

    - #### getDateGrid

          public DateGrid getDateGrid()
                               throws java.lang.IllegalStateException

      A `ListGrid` subclass, responsible for rendering the calendar view.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        DateGrid
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setDayNameLength

          public void setDayNameLength(int dayNameLength)
                                throws java.lang.IllegalStateException

      How long (how many characters) should be day names be. May be 1, 2 or 3 characters.
      Parameters:
        `dayNameLength` - Default value is 2
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDayNameLength

          public int getDayNameLength()

      How long (how many characters) should be day names be. May be 1, 2 or 3 characters.
      Returns:
        int

    - #### setDisabledDates

          public void setDisabledDates(java.util.Date... disabledDates)

      An array of Date instances that should be disabled if they appear in the calendar view.
      Parameters:
        `disabledDates` - Default value is null

    - #### getDisabledDates

          public java.util.Date[] getDisabledDates()

      An array of Date instances that should be disabled if they appear in the calendar view.
      Returns:
        Date...

    - #### setDisabledWeekdayStyle

          public void setDisabledWeekdayStyle(java.lang.String disabledWeekdayStyle)

      Base CSS style applied to weekday dates which have been `disabled`.
      Parameters:
        `disabledWeekdayStyle` - See `CSSStyleName` . Default value is "dateChooserDisabledWeekday"

    - #### getDisabledWeekdayStyle

          public java.lang.String getDisabledWeekdayStyle()

      Base CSS style applied to weekday dates which have been `disabled`.
      Returns:
        See `CSSStyleName`

    - #### setDisabledWeekendStyle

          public void setDisabledWeekendStyle(java.lang.String disabledWeekendStyle)

      Base CSS style applied to weekend dates which have been `disabled`.
      Parameters:
        `disabledWeekendStyle` - See `CSSStyleName` . Default value is "dateChooserDisabledWeekend"

    - #### getDisabledWeekendStyle

          public java.lang.String getDisabledWeekendStyle()

      Base CSS style applied to weekend dates which have been `disabled`.
      Returns:
        See `CSSStyleName`

    - #### setDisableWeekends

          public void setDisableWeekends(java.lang.Boolean disableWeekends)
                                  throws java.lang.IllegalStateException

      Whether it should be valid to pick a weekend day. If set to true, weekend days appear in disabled style and cannot be picked.

      Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.

      Parameters:
        `disableWeekends` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDisableWeekends

          public java.lang.Boolean getDisableWeekends()

      Whether it should be valid to pick a weekend day. If set to true, weekend days appear in disabled style and cannot be picked.

      Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.

      Returns:
        Boolean

    - #### setEndYear

          public void setEndYear(int endYear)
                          throws java.lang.IllegalStateException

      Last year that may be selected.
      Parameters:
        `endYear` - Default value is 2020
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEndYear

          public int getEndYear()

      Last year that may be selected.
      Returns:
        int

    - #### setFirstDayOfWeek

          public void setFirstDayOfWeek(int firstDayOfWeek)
                                 throws java.lang.IllegalStateException

      Day of the week to show in the first column. 0=Sunday, 1=Monday, ..., 6=Saturday. The default value for this attribute is picked up from the current locale and can also be altered system-wide with the `global setter`.
      Parameters:
        `firstDayOfWeek` - Default value is 0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getFirstDayOfWeek

          public int getFirstDayOfWeek()

      Day of the week to show in the first column. 0=Sunday, 1=Monday, ..., 6=Saturday. The default value for this attribute is picked up from the current locale and can also be altered system-wide with the `global setter`.
      Returns:
        int
      See Also:
        `Appearance overview and related methods`

    - #### getFiscalYearChooserButton

          public IButton getFiscalYearChooserButton()
                                             throws java.lang.IllegalStateException

      A button shown in the `navigation layout` which, when clicked, shows a picker for selecting a specific fiscal year.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setFiscalYearFieldTitle

          public void setFiscalYearFieldTitle(java.lang.String fiscalYearFieldTitle)

      Title for the `fiscal year` field in the date grid.
      Parameters:
        `fiscalYearFieldTitle` - Default value is "Year"

    - #### getFiscalYearFieldTitle

          public java.lang.String getFiscalYearFieldTitle()

      Title for the `fiscal year` field in the date grid.
      Returns:
        String

    - #### setFiscalYearHeaderStyle

          public void setFiscalYearHeaderStyle(java.lang.String fiscalYearHeaderStyle)

      Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
      Parameters:
        `fiscalYearHeaderStyle` - See `CSSStyleName` . Default value is null

    - #### getFiscalYearHeaderStyle

          public java.lang.String getFiscalYearHeaderStyle()

      Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
      Returns:
        See `CSSStyleName`

    - #### setHeaderHeight

          public void setHeaderHeight(java.lang.Integer headerHeight)
                               throws java.lang.IllegalStateException

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the header area (containing the navigation buttons) in pixels.
      Parameters:
        `headerHeight` - Default value is 20
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHeaderHeight

          public java.lang.Integer getHeaderHeight()

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the header area (containing the navigation buttons) in pixels.
      Returns:
        Integer

    - #### setHeaderStyle

          public void setHeaderStyle(java.lang.String headerStyle)

      CSS style applied to the day-of-week headers. By default this applies to all days of the week. To apply a separate style to weekend headers, set `weekendHeaderStyle`
      Parameters:
        `headerStyle` - See `CSSStyleName` . Default value is "dateChooserButtonDisabled"

    - #### getHeaderStyle

          public java.lang.String getHeaderStyle()

      CSS style applied to the day-of-week headers. By default this applies to all days of the week. To apply a separate style to weekend headers, set `weekendHeaderStyle`
      Returns:
        See `CSSStyleName`

    - #### getMonthChooserButton

          public IButton getMonthChooserButton()
                                        throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shows a picker for selecting a specific month.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setMonthMenuStyle

          public void setMonthMenuStyle(java.lang.String monthMenuStyle)
                                 throws java.lang.IllegalStateException

      Style for the pop-up year menu.
      Parameters:
        `monthMenuStyle` - See `CSSStyleName` . Default value is "dateChooserMonthMenu"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMonthMenuStyle

          public java.lang.String getMonthMenuStyle()

      Style for the pop-up year menu.
      Returns:
        See `CSSStyleName`

    - #### getNavigationLayout

          public HLayout getNavigationLayout()
                                      throws java.lang.IllegalStateException

      An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered above the `date grid`, and showing a number of widgets for navigating the DateChooser. These include buttons for moving to the previous `year` or `month`, the next `year` or `month`, and for selecting a specific `year`, `month` or `week`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        HLayout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNavigationLayoutHeight

          public void setNavigationLayoutHeight(int navigationLayoutHeight)
                                         throws java.lang.IllegalStateException

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
      Parameters:
        `navigationLayoutHeight` - Default value is 20
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNavigationLayoutHeight

          public int getNavigationLayoutHeight()

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
      Returns:
        int

    - #### getNextMonthButton

          public IButton getNextMonthButton()
                                     throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view forward by a month.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNextMonthIcon

          public void setNextMonthIcon(java.lang.String nextMonthIcon)

      Icon for the next month button
      Parameters:
        `nextMonthIcon` - Default value is "[SKIN]arrow_right.gif"

    - #### getNextMonthIcon

          public java.lang.String getNextMonthIcon()

      Icon for the next month button
      Returns:
        String

    - #### setNextMonthIconHeight

          public void setNextMonthIconHeight(int nextMonthIconHeight)

      Height of the icon for the next month button
      Parameters:
        `nextMonthIconHeight` - Default value is 7

    - #### getNextMonthIconHeight

          public int getNextMonthIconHeight()

      Height of the icon for the next month button
      Returns:
        int

    - #### setNextMonthIconRTL

          public void setNextMonthIconRTL(java.lang.String nextMonthIconRTL)

      Icon for the next month button
      Parameters:
        `nextMonthIconRTL` - Default value is null

    - #### getNextMonthIconRTL

          public java.lang.String getNextMonthIconRTL()

      Icon for the next month button
      Returns:
        String

    - #### setNextMonthIconWidth

          public void setNextMonthIconWidth(int nextMonthIconWidth)

      Width of the icon for the next month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Parameters:
        `nextMonthIconWidth` - Default value is 7

    - #### getNextMonthIconWidth

          public int getNextMonthIconWidth()

      Width of the icon for the next month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Returns:
        int

    - #### getNextYearButton

          public IButton getNextYearButton()
                                    throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view forward by a year.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNextYearIcon

          public void setNextYearIcon(java.lang.String nextYearIcon)
                               throws java.lang.IllegalStateException

      Icon for the next year button
      Parameters:
        `nextYearIcon` - Default value is "[SKIN]doubleArrow_right.gif"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`

    - #### getNextYearIcon

          public java.lang.String getNextYearIcon()

      Icon for the next year button
      Returns:
        String
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`

    - #### setNextYearIconHeight

          public void setNextYearIconHeight(int nextYearIconHeight)

      Height of the icon for the next year button
      Parameters:
        `nextYearIconHeight` - Default value is 7

    - #### getNextYearIconHeight

          public int getNextYearIconHeight()

      Height of the icon for the next year button
      Returns:
        int

    - #### setNextYearIconRTL

          public void setNextYearIconRTL(java.lang.String nextYearIconRTL)
                                  throws java.lang.IllegalStateException

      Icon for the next year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Parameters:
        `nextYearIconRTL` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`

    - #### getNextYearIconRTL

          public java.lang.String getNextYearIconRTL()

      Icon for the next year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Returns:
        String
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`

    - #### setNextYearIconWidth

          public void setNextYearIconWidth(int nextYearIconWidth)
                                    throws java.lang.IllegalStateException

      Width of the icon for the next year button
      Parameters:
        `nextYearIconWidth` - Default value is 14
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNextYearIconWidth

          public int getNextYearIconWidth()

      Width of the icon for the next year button
      Returns:
        int

    - #### getPreviousMonthButton

          public IButton getPreviousMonthButton()
                                         throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view backward by a month.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getPreviousYearButton

          public IButton getPreviousYearButton()
                                        throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view backward by a year.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setPrevMonthIcon

          public void setPrevMonthIcon(java.lang.String prevMonthIcon)
                                throws java.lang.IllegalStateException

      Icon for the previous month button
      Parameters:
        `prevMonthIcon` - Default value is "[SKIN]arrow_left.gif"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIcon

          public java.lang.String getPrevMonthIcon()

      Icon for the previous month button
      Returns:
        String

    - #### setPrevMonthIconHeight

          public void setPrevMonthIconHeight(int prevMonthIconHeight)
                                      throws java.lang.IllegalStateException

      Height of the icon for the previous month button
      Parameters:
        `prevMonthIconHeight` - Default value is 7
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIconHeight

          public int getPrevMonthIconHeight()

      Height of the icon for the previous month button
      Returns:
        int

    - #### setPrevMonthIconRTL

          public void setPrevMonthIconRTL(java.lang.String prevMonthIconRTL)
                                   throws java.lang.IllegalStateException

      Icon for the previous month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Parameters:
        `prevMonthIconRTL` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIconRTL

          public java.lang.String getPrevMonthIconRTL()

      Icon for the previous month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Returns:
        String

    - #### setPrevMonthIconWidth

          public void setPrevMonthIconWidth(int prevMonthIconWidth)
                                     throws java.lang.IllegalStateException

      Width of the icon for the previous month button
      Parameters:
        `prevMonthIconWidth` - Default value is 7
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIconWidth

          public int getPrevMonthIconWidth()

      Width of the icon for the previous month button
      Returns:
        int

    - #### setPrevYearIcon

          public void setPrevYearIcon(java.lang.String prevYearIcon)
                               throws java.lang.IllegalStateException

      Icon for the previous year button
      Parameters:
        `prevYearIcon` - Default value is "[SKIN]doubleArrow_left.gif"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`

    - #### getPrevYearIcon

          public java.lang.String getPrevYearIcon()

      Icon for the previous year button
      Returns:
        String
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`

    - #### setPrevYearIconHeight

          public void setPrevYearIconHeight(int prevYearIconHeight)
                                     throws java.lang.IllegalStateException

      Height of the icon for the previous year button
      Parameters:
        `prevYearIconHeight` - Default value is 7
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevYearIconHeight

          public int getPrevYearIconHeight()

      Height of the icon for the previous year button
      Returns:
        int

    - #### setPrevYearIconRTL

          public void setPrevYearIconRTL(java.lang.String prevYearIconRTL)

      Icon for the previous year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Parameters:
        `prevYearIconRTL` - Default value is null
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`

    - #### getPrevYearIconRTL

          public java.lang.String getPrevYearIconRTL()

      Icon for the previous year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Returns:
        String
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`

    - #### setPrevYearIconWidth

          public void setPrevYearIconWidth(int prevYearIconWidth)
                                    throws java.lang.IllegalStateException

      Width of the icon for the previous year button
      Parameters:
        `prevYearIconWidth` - Default value is 14
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevYearIconWidth

          public int getPrevYearIconWidth()

      Width of the icon for the previous year button
      Returns:
        int

    - #### setSelectedWeekStyle

          public void setSelectedWeekStyle(java.lang.String selectedWeekStyle)

      CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
      Parameters:
        `selectedWeekStyle` - See `CSSStyleName` . Default value is "dateChooserSelectedWeek"

    - #### getSelectedWeekStyle

          public java.lang.String getSelectedWeekStyle()

      CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
      Returns:
        See `CSSStyleName`

    - #### setShowApplyButton

          public void setShowApplyButton(java.lang.Boolean showApplyButton)

      Determines whether the `applyButton` will be displayed.
      Parameters:
        `showApplyButton` - Default value is null

    - #### getShowApplyButton

          public java.lang.Boolean getShowApplyButton()

      Determines whether the `applyButton` will be displayed.
      Returns:
        Boolean

    - #### setShowCancelButton

          public void setShowCancelButton(java.lang.Boolean showCancelButton)

      Determines whether the "Cancel" button will be displayed.
      Parameters:
        `showCancelButton` - Default value is false

    - #### getShowCancelButton

          public java.lang.Boolean getShowCancelButton()

      Determines whether the "Cancel" button will be displayed.
      Returns:
        Boolean

    - #### setShowFiscalYearChooser

          public void setShowFiscalYearChooser(java.lang.Boolean showFiscalYearChooser)

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Parameters:
        `showFiscalYearChooser` - Default value is false

    - #### getShowFiscalYearChooser

          public java.lang.Boolean getShowFiscalYearChooser()

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Returns:
        Boolean

    - #### setShowSecondItem

          public void setShowSecondItem(java.lang.Boolean showSecondItem)

      When showing the `time field`, whether to show the "second" picker. When unset, the second field is not shown.
      Parameters:
        `showSecondItem` - Default value is null

    - #### getShowSecondItem

          public java.lang.Boolean getShowSecondItem()

      When showing the `time field`, whether to show the "second" picker. When unset, the second field is not shown.
      Returns:
        Boolean

    - #### setShowTimeItem

          public void setShowTimeItem(java.lang.Boolean showTimeItem)

      Whether to show the `time field` for editing the time portion of the date. When unset, the time field is shown automatically if the field type is "datetime".
      Parameters:
        `showTimeItem` - Default value is null

    - #### getShowTimeItem

          public java.lang.Boolean getShowTimeItem()

      Whether to show the `time field` for editing the time portion of the date. When unset, the time field is shown automatically if the field type is "datetime".
      Returns:
        Boolean

    - #### setShowTodayButton

          public void setShowTodayButton(java.lang.Boolean showTodayButton)

      Determines whether the "Today" button will be displayed, allowing the user to select the current date.
      Parameters:
        `showTodayButton` - Default value is true

    - #### getShowTodayButton

          public java.lang.Boolean getShowTodayButton()

      Determines whether the "Today" button will be displayed, allowing the user to select the current date.
      Returns:
        Boolean

    - #### setShowWeekChooser

          public void setShowWeekChooser(java.lang.Boolean showWeekChooser)

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
      Parameters:
        `showWeekChooser` - Default value is false

    - #### getShowWeekChooser

          public java.lang.Boolean getShowWeekChooser()

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
      Returns:
        Boolean

    - #### setShowWeekends

          public void setShowWeekends(java.lang.Boolean showWeekends)
                               throws java.lang.IllegalStateException

      Whether weekend days should be shown. Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.
      Parameters:
        `showWeekends` - Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowWeekends

          public java.lang.Boolean getShowWeekends()

      Whether weekend days should be shown. Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.
      Returns:
        Boolean

    - #### setSkinImgDir

          public void setSkinImgDir(java.lang.String skinImgDir)

      Overridden directory where images for this widget (such as the month and year button icons) may be found.

      Note : This is an advanced setting

      Overrides:
        `setSkinImgDir` in class `Canvas`
      Parameters:
        `skinImgDir` - Default value is "images/common/"
      See Also:
        `Images overview and related methods`

    - #### getSkinImgDir

          public java.lang.String getSkinImgDir()

      Overridden directory where images for this widget (such as the month and year button icons) may be found.
      Overrides:
        `getSkinImgDir` in class `Canvas`
      Returns:
        String
      See Also:
        `Images overview and related methods`

    - #### setStartYear

          public void setStartYear(int startYear)
                            throws java.lang.IllegalStateException

      Earliest year that may be selected.
      Parameters:
        `startYear` - Default value is 1995
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStartYear

          public int getStartYear()

      Earliest year that may be selected.
      Returns:
        int

    - #### getTimeItem

          public TimeItem getTimeItem()
                               throws java.lang.IllegalStateException

      `TimeItem` for editing the time portion of dates. Visible by default for fields of type "datetime" and can be controlled by setting `showTimeItem`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        TimeItem
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTimeItemProperties

          public void setTimeItemProperties(TimeItem timeItemProperties)
                                     throws java.lang.IllegalStateException

      Custom properties to apply to the `time field` used for editing the time portion of the date.

      Note : This is an advanced setting

      Parameters:
        `timeItemProperties` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTimeItemProperties

          public TimeItem getTimeItemProperties()

      Custom properties to apply to the `time field` used for editing the time portion of the date.
      Returns:
        TimeItem

    - #### setTimeItemTitle

          public void setTimeItemTitle(java.lang.String timeItemTitle)

      Title for the `time field`.
      Parameters:
        `timeItemTitle` - Default value is "Time"

    - #### getTimeItemTitle

          public java.lang.String getTimeItemTitle()

      Title for the `time field`.
      Returns:
        String

    - #### getTodayButton

          public IButton getTodayButton()
                                 throws java.lang.IllegalStateException

      A button shown below the `calendar grid` which, when clicked, navigates the calendar to today.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTodayButtonHeight

          public void setTodayButtonHeight(java.lang.Integer todayButtonHeight)

      If set specifies a fixed height for the Today and Cancel buttons.
      Parameters:
        `todayButtonHeight` - Default value is null

    - #### getTodayButtonHeight

          public java.lang.Integer getTodayButtonHeight()

      If set specifies a fixed height for the Today and Cancel buttons.
      Returns:
        Integer

    - #### setTodayButtonTitle

          public void setTodayButtonTitle(java.lang.String todayButtonTitle)

      Title for "Today" button.
      Parameters:
        `todayButtonTitle` - Default value is "Today"

    - #### getTodayButtonTitle

          public java.lang.String getTodayButtonTitle()

      Title for "Today" button.
      Returns:
        String

    - #### setUse24HourTime

          public void setUse24HourTime(java.lang.Boolean use24HourTime)

      When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time. The default is true.
      Parameters:
        `use24HourTime` - Default value is true

    - #### getUse24HourTime

          public java.lang.Boolean getUse24HourTime()

      When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time. The default is true.
      Returns:
        Boolean

    - #### setUseFirstDayOfFiscalWeek

          public void setUseFirstDayOfFiscalWeek(java.lang.Boolean useFirstDayOfFiscalWeek)

      When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
      Parameters:
        `useFirstDayOfFiscalWeek` - Default value is true

    - #### getUseFirstDayOfFiscalWeek

          public java.lang.Boolean getUseFirstDayOfFiscalWeek()

      When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
      Returns:
        Boolean

    - #### getWeekChooserButton

          public IButton getWeekChooserButton()
                                       throws java.lang.IllegalStateException

      A button shown in the `navigation layout` which shows a picker for selecting a specific week of the year. When `showFiscalYearChooser` is true, the week number represents a fiscal week number, one offset from the start of the fiscal year. Otherwise, it represents a week number offset from the start of the calendar year.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setWeekendDays

          public void setWeekendDays(int... weekendDays)

      An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance. If unset, defaults to the set of days indicated `globally`.
      Parameters:
        `weekendDays` - Default value is null
      See Also:
        `Visibility overview and related methods`

    - #### getWeekendDays

          public int[] getWeekendDays()

      An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance. If unset, defaults to the set of days indicated `globally`.
      Returns:
        int...
      See Also:
        `Visibility overview and related methods`

    - #### setWeekendHeaderStyle

          public void setWeekendHeaderStyle(java.lang.String weekendHeaderStyle)

      Optional CSS style applied to the day-of-week headers for weekend days. If unset `headerStyle` will be applied to both weekdays and weekend days.
      Parameters:
        `weekendHeaderStyle` - Default value is null

    - #### getWeekendHeaderStyle

          public java.lang.String getWeekendHeaderStyle()

      Optional CSS style applied to the day-of-week headers for weekend days. If unset `headerStyle` will be applied to both weekdays and weekend days.
      Returns:
        String

    - #### setWeekFieldTitle

          public void setWeekFieldTitle(java.lang.String weekFieldTitle)

      Title for the `week` field in the date grid.
      Parameters:
        `weekFieldTitle` - Default value is "Wk"

    - #### getWeekFieldTitle

          public java.lang.String getWeekFieldTitle()

      Title for the `week` field in the date grid.
      Returns:
        String

    - #### setWeekHeaderStyle

          public void setWeekHeaderStyle(java.lang.String weekHeaderStyle)

      Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
      Parameters:
        `weekHeaderStyle` - See `CSSStyleName` . Default value is null

    - #### getWeekHeaderStyle

          public java.lang.String getWeekHeaderStyle()

      Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
      Returns:
        See `CSSStyleName`

    - #### setWeekMenuStyle

          public void setWeekMenuStyle(java.lang.String weekMenuStyle)
                                throws java.lang.IllegalStateException

      Style for the pop-up week menu.
      Parameters:
        `weekMenuStyle` - See `CSSStyleName` . Default value is "dateChooserWeekMenu"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getWeekMenuStyle

          public java.lang.String getWeekMenuStyle()

      Style for the pop-up week menu.
      Returns:
        See `CSSStyleName`

    - #### getYearChooserButton

          public IButton getYearChooserButton()
                                       throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shows a picker for selecting a specific calendar year.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        IButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setYearMenuStyle

          public void setYearMenuStyle(java.lang.String yearMenuStyle)
                                throws java.lang.IllegalStateException

      Style for the pop-up year menu.
      Parameters:
        `yearMenuStyle` - See `CSSStyleName` . Default value is "dateChooserYearMenu"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getYearMenuStyle

          public java.lang.String getYearMenuStyle()

      Style for the pop-up year menu.
      Returns:
        See `CSSStyleName`

    - #### cancelClick

          public void cancelClick()

      Fired when the user clicks the cancel button in this date chooser. Default implementation clears the date chooser.

    - #### addDataChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addDataChangedHandler(DataChangedHandler handler)

      Add a dataChanged handler.

      Method to override or observe in order to be notified when a user picks a date value.

      Has no default behavior (so no need to call Super).

      Use `DateChooser.getData()` to get the current date value.

      Specified by:
        `addDataChangedHandler` in interface `HasDataChangedHandlers`
      Parameters:
        `handler` - the dataChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### getData

          public java.util.Date getData()

      Get the current value of the picker.

      See `DateChooser.dataChanged()` for how to respond to the user picking a date.

      Returns:
        current date

    - #### getFiscalCalendar

          public FiscalCalendar getFiscalCalendar()

      Returns the `FiscalCalendar` object that will be used by this DateChooser.
      Returns:
        the fiscal calendar for this chooser, if set, or the global one otherwise

    - #### setData

          public void setData(java.util.Date date)

      Set the picker to show the given date.
      Parameters:
        `date` - new value

    - #### setFiscalCalendar

          public void setFiscalCalendar()

      Sets the `FiscalCalendar` object that will be used by this DateChooser. If unset, the `global fiscal calendar` is used.

    - #### setFiscalCalendar

          public void setFiscalCalendar(FiscalCalendar fiscalCalendar)

      Sets the `FiscalCalendar` object that will be used by this DateChooser. If unset, the `global fiscal calendar` is used.
      Parameters:
        `fiscalCalendar` - the fiscal calendar for this chooser

    - #### todayClick

          public void todayClick()

      Fired when the user clicks the Today button. Default implementation will select the current date in the date chooser.

    - #### setDefaultProperties

          public static void setDefaultProperties(DateChooser dateChooserProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `dateChooserProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setYearTitleFormatter

          public void setYearTitleFormatter(DateChooser.YearTitleFormatter formatter)

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.DateChooserLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`